// Copyright (c) 2010 Luis Semp
// http://www.luissempe.com
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

#include <iostream>

#include "StateQuery.h"
#include "StateGraphData.h"
#include "StateTypes.h"
#include "StateQueryData.h"

StateQuery::StateQuery(State* state, StateGraph* stateGraph)
: BaseState(state, stateGraph)
{
}

StateQuery::~StateQuery()
{
}

void StateQuery::OnEntry()
{
	StateQueryData* data = static_cast<StateQueryData*>( m_state->mStateData );
	std::cout << "StateQuery::OnEntry " << "\n";
}

BaseState::Status StateQuery::Process()
{
	StateQueryData* data = static_cast<StateQueryData*>( m_state->mStateData );
	std::cout << "StateQuery::Process " << data->mQueryInt << " " << data->mQueryText << "\n";
	return BaseState::Done;
}

void StateQuery::OnExit()
{
	StateQueryData* data = static_cast<StateQueryData*>( m_state->mStateData );
	std::cout << "StateQuery::OnExit " << "\n\n";
}
